# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   pythonProject
# FileName:      __init__.py
# Author:       xxxxxxx
# Datetime:     2024/1/4 19:11
# Description:
# 命名规范：文件名全小写+下划线，类名大驼峰，方法和变量小写+下划线连接，
# 常量大写，变量和常量用名词，方法用动词
# ---------------------------------------------------------------------------
import os.path

from APIAutoTest_v2_my.common.log import log

# 设定日志路径
log_path = os.path.join(os.path.dirname(os.path.dirname(__file__)),"report/log/bpm.log")

# 创建日志对象
my_logger = log(log_path)


# 设置日志装饰器
def log_decorator(func):
    def inner(*args, **kwargs):
        try:
            my_logger.info("方法或函数的名称为："+str(func.__name__)+"方法或函数的功能为："+str(func.__doc__))
            value = func(*args,**kwargs)
        except Exception as e:
            my_logger.error('方法或函数的名称为：'+str(func.__name__)+"报错为："+str(e))
        else:
            return value
    return inner