# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   pythonProject
# FileName:      log.py
# Author:       xxxxxxx
# Datetime:     2024/1/4 18:48
# Description:
# 命名规范：文件名全小写+下划线，类名大驼峰，方法和变量小写+下划线连接，
# 常量大写，变量和常量用名词，方法用动词
# ---------------------------------------------------------------------------
import logging


# 日志功能
def log(filename):
    # 获取日志对象
    my_logger = logging.getLogger()
    # 创建了一个日志文件
    handler = logging.FileHandler(filename,mode='a',encoding='utf-8')
    # 定义日志的格式
    formatter = logging.Formatter('%(levelname)s--%(asctime)s--%(message)s')
    '''
        %(levelname)s:代表日志消息级别
        %(asctime)s:代表日志消息的时间戳
        %(message)s:代表日志消息的内容
    '''
    # 将上面日志的定义的格式设置为日志格式
    handler.setFormatter(formatter)
    # 将上面创建的日志文件添加为日志
    my_logger.addHandler(handler)
    # 将日志级别设定为INFO
    my_logger.level = logging.INFO
    '''
        这段代码将名为my_logger的Logger对象的日志级别设置为logging.INFO。在Python的logging模块中，日志级别用于表示日志消息的重要程度，不同的级别包括DEBUG、INFO、WARNING、ERROR、CRITICAL等。通过将Logger对象的级别设置为特定的级别，可以控制记录在日志中的消息的级别，比如只记录INFO级别及以上的消息。

在这个例子中，将my_logger的级别设置为logging.INFO表示只记录INFO级别及以上的日志消息，而低于INFO级别的消息（如DEBUG）将不会被记录。这样可以灵活地控制日志输出的详细程度，以便在不同环境下进行调试和监控。
    '''
    return my_logger
