# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   pythonProject
# FileName:      read_json.py
# Author:       xxxxxxx
# Datetime:     2024/1/3 14:16
# Description:
# 命名规范：文件名全小写+下划线，类名大驼峰，方法和变量小写+下划线连接，
# 常量大写，变量和常量用名词，方法用动词
# ---------------------------------------------------------------------------

'''
    根据传入的路径读取json文件，并将json文件中的内容转换为对象并返回
'''
import json
import os.path


def read_json(filepath):
    # 判断传入的路径是否是文件且以json文件结尾
    # 如果是就读取文件内容
    if os.path.isfile(filepath) and filepath.endswith('json'):
        # 创建文件对象
        with open(filepath, mode='r', encoding='utf-8') as file:
            # 将文件内容转换为json对象
            try:
                res = json.loads(file.read())
            except:
                raise FileExistsError('传入的json文件格式错误！')
            else:
                return res
    # 不是json文件
    else:
        raise FileNotFoundError('传入的json路径不存在！')

