# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   test_58
# FileName:      test_bpm.py
# Author:       xxxxxxx
# Datetime:     2024/1/3 15:20
# Description:
# 
# ---------------------------------------------------------------------------
import logging
import os

import pytest

from APIAutoTest_v3.common.read_excel import ReadExcel


laowang_dir_path = os.path.join(os.path.join(os.path.dirname(os.path.dirname(os.path.dirname(__file__))), "data_config"), "老王")
excel_path = os.path.join(laowang_dir_path, "laowang.xlsx")
case_data_path = os.path.join(laowang_dir_path, "case_data.json")
expect_data_path = os.path.join(laowang_dir_path, "expect_data.json")
sql_data_path = os.path.join(laowang_dir_path, "sql_data.json")



class TestBPM:

    @pytest.mark.parametrize("case_url, case_req, case_mime, case_data, expect_data, sql_type, sql_data, update_key", ReadExcel(excel_path=excel_path,table_name=r'BPM', case_data_path=case_data_path, expect_data_path=expect_data_path, sql_data_path=sql_data_path).get_data())
    def test_bpm(self, db_fix, req_fix, case_url, case_req, case_mime, case_data, expect_data, sql_type, sql_data, update_key):
        # 判断sql语句的类型是否为delete
        if sql_type == "delete":
            # 使用DB类对象，调用delete方法执行删除的sql语句
            db_fix.delete(sql_data)
            # 发送请求
        # 判断sql语句类型是否为select
        elif sql_type == "select":
            # 使用DB类对象，调用select方法执行查询的sql语句，并接收查询的结果
            select_result = db_fix.select(sql_data)
            # 将查询结果更新到用例数据中
            case_data[update_key] = select_result
            # 更新之后的用例数据发送给服务器。

        # 判断sql语句类型是否为select|delete或者delete|select
        elif sql_type == "select|delete" or sql_type == "delete|select":
            # 使用DB类对象，调用select方法执行查询sql语句，并接收查询的结果，将查询的结果更新到用例数据中
            select_result = db_fix.select(sql_data.get("select"))
            case_data[update_key] = select_result
            # 使用DB类对象，调用delete方法执行删除sql语句
            db_fix.delete(sql_data.get("delete"))

        # 使用RequestsMethod对象发送请求
        result = req_fix.request_all(req_method=case_req, req_url=case_url, req_mime=case_mime, case_data=case_data)

        # 断言
        try:
            # 获取期望数据的key，期望数据的key对应的值是否和服务器返回的数据key对应的值相等，如果相等断言成功，否则断言失败
            for key in expect_data.keys():
                assert expect_data[key] == result.json().get(key)
        except AssertionError:
            logging.error("断言失败，用例数据为："+str(case_data)+" 期望数据为："+str(expect_data)+" 服务器返回的数据为："+result.text)
            raise AssertionError("断言失败")


if __name__ == '__main__':
    pytest.main()