# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   pythonProject
# FileName:      test_bpm.py
# Author:       xxxxxxx
# Datetime:     2024/1/4 14:18
# Description:
# 命名规范：文件名全小写+下划线，类名大驼峰，方法和变量小写+下划线连接，
# 常量大写，变量和常量用名词，方法用动词
# ---------------------------------------------------------------------------
import logging

import pytest

from APIAutoTest_v2_my.common.read_excel import ReadExcel


class TestBPM:
    @pytest.mark.parametrize(
        "request_url, request_method, request_mime, case_data, except_data, sql_type,sql_sentence, key",
        ReadExcel().get_data())
    def test_bpm(self, db_fix, req_fix, request_url, request_method, request_mime, case_data, except_data, sql_type,
                 sql_sentence, key):
        # 如果sql_type是delete就执行删除
        if sql_type == 'delete':
            db_fix.delete(sql_sentence)
        elif sql_type == "select":
            # 执行DB类对象，使用select方法执行查询的sql语句，并接收查询结果
            select_result = db_fix.select(sql_sentence)
            # 将查询结果更新到用例数据中
            case_data[key] = select_result
        elif sql_type == "select|delete" or sql_type == "delete|select":
            # 执行删除
            db_fix.delete(sql_sentence.get('delete'))
            # 执行查询
            select_result = db_fix.select(sql_sentence.get('select'))
            # 将查询结果更新到用例数据中
            case_data[key] = select_result
        # 向服务器发送请求
        result = req_fix.request_all(req_url=request_url, req_method=request_method, req_mime=request_mime,
                                     req_data=case_data)

        # 断言
        try:
            for key in except_data.keys():
                assert except_data[key] == result.json().get(key)
        except AssertionError:
            logging.error('断言失败！'+'用例数据为'+str(case_data)+'期望数据为'+str(except_data)+'客户端返回的数据为'+str(result.text))
            raise AssertionError('断言失败')


if __name__ == '__main__':
    pytest.main()
